
/**********************************************************************

CSWObject.h

Mark Cederholm - 04/25/2001

CSWObject - an OLE Helper class for Smallworld Automation Objects

This is actually a pretty generic class and can be used for other
automation objects as well.

**********************************************************************/


#include <afx.h>
#include <afxwin.h>
// #include <afxext.h>
// #include <afxcmn.h>
#include <afxdtctl.h>
#include <afxtempl.h>

class CSWObject
{
public:

   // constructor

   CSWObject(){};

   // operations

   void init(LPDISPATCH pDispatch);
   HRESULT get(LPOLESTR szName, LPVARIANT pvRet);
   HRESULT set(LPOLESTR szName, LPVARIANT pvArg, LPVARIANT pvRet);
   HRESULT do_variant(LPOLESTR szName, LPVARIANT pvArg, LPVARIANT pvRet);
   HRESULT do_dispparams(LPOLESTR szName, DISPPARAMS * pdArg, LPVARIANT pvRet);

private:

   // attributes

   LPDISPATCH my_lpdispatch;
   CMap<LPOLESTR, LPOLESTR, DISPID, DISPID&> my_dispid_table;
      // used to store property/method names and ids

   // operations

   HRESULT get_id(LPOLESTR pszName, DISPID * dispid);
   HRESULT do_invoke(DISPID dispid, WORD dispatch_type, DISPPARAMS * pdArg, LPVARIANT pvRet);

};


