// SiSLAddin.cpp : Implementation of CSiSLAddin
#include "stdafx.h"
#include "SiShpLdr.h"
#include "SiSLAddin.h"

/////////////////////////////////////////////////////////////////////////////
// CSiSLAddin

// SI apparently has trouble dealing with returned error codes,
// so all interface methods return NOERROR

STDMETHODIMP CSiSLAddin::get_AddInProperties(_SIAddInProperties * * prop)
{

   GenAddInProperties(prop);
   return NOERROR;

}

STDMETHODIMP CSiSLAddin::Initialise(IDispatch * * SpatialIntelligence)
{

   (*SpatialIntelligence)->AddRef();
   SWInitialized = dlg.InitSW(SpatialIntelligence);
   return NOERROR;

}

STDMETHODIMP CSiSLAddin::Activate(VARIANT * Custom)
{

   if (!SWInitialized)
      return NOERROR;
   if (dlg.m_hWnd == NULL)
      dlg.Create(dlg.IDD, NULL);
   dlg.ShowWindow(SW_SHOW);
   return NOERROR;

}

STDMETHODIMP CSiSLAddin::Terminate(VARIANT * Custom)
{

   if (SWInitialized)
      dlg.DestroyWindow();
   return NOERROR;

}

/////////////////////////////////////////////////////////////////////////////
// CSiSLAddin Private Methods

void CSiSLAddin::GenAddInProperties(_SIAddInProperties * * prop)
{

   BSTR bs1;  // I can't get these functions to work with _bstr_t
   HRESULT hr;
   LPDISPATCH pdisp = NULL;
   LPUNKNOWN punk = NULL;
   LPWSTR ls1;
   short Major = 1;
   short Minor = 1;
   short Revision = 0;

   // Create an instance of _SIAddInProperties and assign to prop

   *prop = NULL;
   hr = CoCreateInstance(CLSID_SIAddInProperties, NULL, CLSCTX_SERVER,
                           IID_IUnknown, (LPVOID *)&punk);
   if (FAILED(hr))
   {
      if (punk) punk->Release();
      return;
   }

   hr = punk->QueryInterface(IID__SIAddInProperties, (LPVOID *)&pdisp);
   if (FAILED(hr))
   {
      if (punk) punk->Release();
      if (pdisp) pdisp->Release();
      return;
   }

   *prop = (_SIAddInProperties *)pdisp;
   punk->Release();

   // Set properties

   ls1 = L"SI User";
   bs1 = SysAllocString(ls1);
   (*prop)->put_CompanyName(&bs1);
   ls1 = L"SI Shapefile Loader";
   bs1 = SysAllocString(ls1);
   (*prop)->put_Title(&bs1);
   ls1 = L"Invokes dialog to import shapefile data into the project datastore.";
   bs1 = SysAllocString(ls1);
   (*prop)->put_Description(&bs1);
   (*prop)->put_Major(&Major);
   (*prop)->put_Minor(&Minor);
   (*prop)->put_Revision(&Revision);

   return;

}

