// SiSLDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SiShpLdr.h"
#include "SiSLDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define IDT_TIMER 1   // timer ID for dialog

/////////////////////////////////////////////////////////////////////////////
// SiSLDlg dialog


SiSLDlg::SiSLDlg(CWnd* pParent /*=NULL*/)
        : CDialog(SiSLDlg::IDD, pParent)
{
        EnableAutomation();

        //{{AFX_DATA_INIT(SiSLDlg)
        m_sShpPath = _T("");
        m_sTabName = _T("");
        m_dSF = 1.0;
        //}}AFX_DATA_INIT
}


void SiSLDlg::OnFinalRelease()
{
        // When the last reference for an automation object is released
        // OnFinalRelease is called.  The base class will automatically
        // deletes the object.  Add additional cleanup required for your
        // object before calling the base class.

        CDialog::OnFinalRelease();
}

void SiSLDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(SiSLDlg)
        DDX_Control(pDX, IDC_TABNAME, m_cTabName);
        DDX_Control(pDX, IDC_SHPPATH, m_cShpPath);
        DDX_Control(pDX, IDC_STATUS, m_cStatus);
        DDX_Text(pDX, IDC_SHPPATH, m_sShpPath);
        DDV_MaxChars(pDX, m_sShpPath, 256);
        DDX_Text(pDX, IDC_TABNAME, m_sTabName);
        DDV_MaxChars(pDX, m_sTabName, 40);
        DDX_Text(pDX, IDC_SF, m_dSF);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(SiSLDlg, CDialog)
        //{{AFX_MSG_MAP(SiSLDlg)
        ON_WM_CLOSE()
        ON_BN_CLICKED(IDRUN, OnRun)
        ON_BN_CLICKED(IDC_INTERRUPT, OnInterrupt)
        ON_WM_TIMER()
        ON_BN_CLICKED(IDC_FILEDIALOG, OnFileDialog)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(SiSLDlg, CDialog)
        //{{AFX_DISPATCH_MAP(SiSLDlg)
                // NOTE - the ClassWizard will add and remove mapping macros here.
        //}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_ISiSLDlg to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the
//  dispinterface in the .ODL file.

// {75001721-9741-11D5-B490-0002A5375342}
static const IID IID_ISiSLDlg =
{ 0x75001721, 0x9741, 0x11d5, { 0xb4, 0x90, 0x0, 0x2, 0xa5, 0x37, 0x53, 0x42 } };

BEGIN_INTERFACE_MAP(SiSLDlg, CDialog)
        INTERFACE_PART(SiSLDlg, IID_ISiSLDlg, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SiSLDlg message handlers

void SiSLDlg::OnFileDialog()
{

   CFileDialog * pcBrowse;
   CString Path, Title, NewPath;
   int i;

   // Invoke file picker

   pcBrowse = (CFileDialog*)new CFileDialog(TRUE, _T("shp"), NULL,
                 OFN_HIDEREADONLY, _T("Shapefiles|*.shp||"), NULL);
   if (pcBrowse->DoModal() == IDCANCEL)
      return;

   // Get path name and strip off ".shp"

   Title = pcBrowse->GetFileTitle();
   Title.MakeLower();
   Path = pcBrowse->GetPathName();
   Path.MakeLower();
   i = Path.Find(".shp");
   NewPath = Path.Left(i);

   // Update controls

   m_cShpPath.SetWindowText(NewPath);
   m_cTabName.SetWindowText(Title);
   UpdateData(TRUE);

   delete pcBrowse;

}

void SiSLDlg::OnRun()
{

   // Check if process is already active

   if (IsBusy())
   {
      AfxMessageBox(_T("Error: process is already active."));
      return;
   }

   // Update m_values from controls

   UpdateData(TRUE);

   // Check for invalid parameters

   if (m_sShpPath == "")
   {
      AfxMessageBox(_T("Error: no shapefile path given."));
      m_cStatus.SetWindowText(_T("ERROR"));
      return;
   }

   if (m_sTabName == "")
   {
      AfxMessageBox(_T("Error: no table name given."));
      return;
   }

   if (m_dSF <= 0.0)
   {
      AfxMessageBox(_T("Error: invalid scaling factor."));
      return;
   }

   // Do it!

   DoIt();

}

void SiSLDlg::OnInterrupt()
{

   _variant_t vResult;
   DISPPARAMS NoArgs = {NULL, NULL, 0, 0};
   HRESULT hResult;

   // Interrupt helper if busy

   if (!IsBusy())
      return;

   hResult = Helper.do_dispparams(L"interrupt", &NoArgs, &vResult);
      // returns null VT_DISPATCH

}

void SiSLDlg::OnCancel()
{

   OnInterrupt();
   CDialog::OnCancel();

}

void SiSLDlg::OnClose()
{

   OnInterrupt();
   CDialog::OnClose();

}

void SiSLDlg::OnTimer(UINT nIDEvent)
{

   _bstr_t b;
   _variant_t vResult;
   BOOL Commit;
   char sbuf[11];
   CString S, msg;
   DISPPARAMS NoArgs = {NULL, NULL, 0, 0};
   HRESULT hResult;
   long size;

   CDialog::OnTimer(nIDEvent);

   // This shouldn't happen

   if (nIDEvent != IDT_TIMER)
      return;

   // Get progress string

   hResult = Helper.get(L"progress_string", &vResult);
   b = _bstr_t(vResult);
   S = (char *) b;
   m_cStatus.SetWindowText(S);

   // If still busy, we're done for now

   if (IsBusy())
      return;

   // Kill the timer

   KillTimer(IDT_TIMER);

   // If processed finished OK, commit changes

   Commit = FALSE;
   if (S == "Done.")
      Commit = TRUE;
   else
   {
      // Otherwise (interrupt or error) ask for commit

      if (AfxMessageBox(_T("Commit changes?"), MB_YESNO) == IDYES)
         Commit = TRUE;
   }

   if (!Commit)
   {
      // Rollback and we're done

      hResult = Helper.do_dispparams(L"rollback", &NoArgs, &vResult);
         // returns null VT_DISPATCH
      m_cStatus.SetWindowText("CANCEL");
      return;
   }

   // Commit changes

   hResult = Helper.do_dispparams(L"commit", &NoArgs, &vResult);
      // returns null VT_DISPATCH

   // Report number of records loaded

   hResult = Helper.do_dispparams(L"get_num_loaded", &NoArgs, &vResult);
      // returns VT_I4
   size = vResult.lVal;
   msg = _itoa(size, sbuf, 10);
   msg = msg + " records loaded.";
   AfxMessageBox(msg);
   m_cStatus.SetWindowText("OK");

   return;

}

/////////////////////////////////////////////////////////////////////////////
// SiSLDlg public methods and overrides

BOOL SiSLDlg::InitSW(IDispatch * * SpatialIntelligence)
{

   _bstr_t b;
   _variant_t vArg, vResult;
   CSWObject CF, M, EX, P;
   DISPPARAMS NoArgs = {NULL, NULL, 0, 0};
   HRESULT hResult;
   LPDISPATCH lpDisp;

   // Get connection to Smallworld Server

   SI.init(*SpatialIntelligence);
   hResult = SI.get(L"ClientFramework", &vResult);
      // assume hresult == S_OK and V_VT(&vResult) == VT_DISPATCH
   CF.init(V_DISPATCH(&vResult));
   hResult = CF.get(L"SmallworldConnection", &vResult);
      // assume hresult == S_OK and V_VT(&vResult) == VT_DISPATCH
   M.init(V_DISPATCH(&vResult));

   // Get the si_shp_loader exemplar

   vArg.SetString("si_shp_loader");
   hResult = M.do_variant(L"GetMagikObject", &vArg, &vResult);
   lpDisp = V_DISPATCH(&vResult);
   if (lpDisp == NULL)
   {
      AfxMessageBox(_T("Error: si_shp_loader class not installed"));
      return FALSE;
   }
   EX.init(lpDisp);

   // Create a new si_shp_loader object

   hResult = EX.do_dispparams(L"new", &NoArgs, &vResult);
      // assume hResult == S_OK and V_VT(&vResult) == VT_DISPATCH
   lpDisp = V_DISPATCH(&vResult);
   lpDisp->AddRef();
   Helper.init(lpDisp);

   return TRUE;

}

BOOL SiSLDlg::OnInitDialog()
{
   CDialog::OnInitDialog();

   // Set text of status label

   m_cStatus.SetWindowText(_T("OK"));

   return TRUE;  // return TRUE  unless you set the focus to a control
}

/////////////////////////////////////////////////////////////////////////////
// SiSLDlg private methods

BOOL SiSLDlg::IsBusy()
{

   _variant_t vResult;
   HRESULT hResult;

   hResult = Helper.get(L"busy?", &vResult);
   return vResult.boolVal;

}

void SiSLDlg::DoIt()
{

   _variant_t vArg, vResult;
   DISPPARAMS NoArgs = {NULL, NULL, 0, 0};
   HRESULT hResult;
   UINT uResult;

   // Reset Helper

   hResult = Helper.do_dispparams(L"reset", &NoArgs, &vResult);
      // returns null VT_DISPATCH

   // Get shapefile path value and set it on Helper

   vArg.SetString(m_sShpPath);
   hResult = Helper.do_variant(L"set_shp_path", &vArg, &vResult);
      // returns VT_BOOL
   if (!vResult.boolVal)
   {
      AfxMessageBox(_T("Error: unable to open shapefile."));
      m_cStatus.SetWindowText(_T("ERROR"));
      return;
   }

   // Build project table

   m_cStatus.SetWindowText(_T("Creating project table..."));
   if (!BuildProjectTable())
   {
      m_cStatus.SetWindowText(_T("ERROR"));
      return;
   }

   // Set scale factor

   if (m_dSF != 1.0)
   {
      vArg.dblVal = m_dSF;
      vArg.vt = VT_R8;
      hResult = Helper.do_variant(L"set_scale_factor", &vArg, &vResult);
         // returns null VT_DISPATCH
   }

   // Start helper thread

   m_cStatus.SetWindowText(_T("Loading..."));
   hResult = Helper.do_dispparams(L"do_it", &NoArgs, &vResult);
      // returns null VT_DISPATCH

   // Now create a timer to trigger the OnTimer handler

   uResult = SetTimer(IDT_TIMER, 1000, NULL);
   if (uResult == 0)   // Hopefully this won't happen
   {
      AfxMessageBox(_T("Error: cannot create timer for process."));
      OnInterrupt();
      m_cStatus.SetWindowText(_T("ERROR"));
   }

   return;

}

BOOL SiSLDlg::BuildProjectTable()
{

   _bstr_t b;
   _variant_t vArg, vResult;
   BOOL IsKey, Success;
   BSTR GeomType, fieldType, IntName, ExternalName;
   CString cIntName;
   CSWObject P, V, D;
   DISPPARAMS NoArgs = {NULL, NULL, 0, 0};
   HRESULT hResult;
   long i, size;
   LPDISPATCH lpDisp;
   LPWSTR ls1;

   _SIDetachedTable * dTable;
   _SIField * NewField;
   _SIFields * SIFields;
   _SIGeometries * SIGeometries;
   _SIProjectTable * pTable;
   _SIProjectTables *SITables;

   // Get _SIProjectTables object

   hResult = SI.get(L"Project", &vResult);
   P.init(V_DISPATCH(&vResult));
   hResult = P.get(L"ProjectTables", &vResult);
   lpDisp = V_DISPATCH(&vResult);
   SITables = new _SIProjectTables(lpDisp);

   // Check if table already exists

   if (TableExists(SITables))
   {
      AfxMessageBox(_T("Error: project table name already exists."));
      delete SITables;
      return FALSE;
   }

   // Get unique internal table name

   vArg.SetString(m_sTabName);
   hResult = Helper.do_variant(L"find_internal_table_name", &vArg, &vResult);
      // returns VT_BSTR
   cIntName = (CString) vResult.bstrVal;

   // Create detached table

   dTable = new _SIDetachedTable();
   dTable->CreateDispatch("SsiTables.SIDetachedTable");
   dTable->SetExternalName(m_sTabName);
   dTable->SetIntName(cIntName);
   dTable->SetTableType(AddIn);
   SIFields = new _SIFields();
   SIFields->CreateDispatch("SsiTables.SIFields");
   dTable->SetRefAttributes(SIFields->m_lpDispatch);
   SIGeometries = new _SIGeometries();
   SIGeometries->CreateDispatch("SsiTables.SIGeometries");
   dTable->SetRefGeometries(SIGeometries->m_lpDispatch);

   // Create key field

   ls1 = L"ds_int";
   fieldType = SysAllocString(ls1);
   IsKey = TRUE;
   ls1 = L"int!id";
   IntName = SysAllocString(ls1);
   lpDisp = SIFields->Add(&fieldType, &IsKey, &IntName, &IntName, &IntName);
   NewField = new _SIField(lpDisp);
   NewField->SetVisible(FALSE);
   NewField->SetIsGenerated(&IsKey);

   // Get shapefile geometry type and add to project table

   hResult = Helper.do_dispparams(L"get_geom_type", &NoArgs, &vResult);
      // returns VT_BSTR
   GeomType = vResult.bstrVal;
   b = "Geom!" + (_bstr_t) GeomType;
   ExternalName = SysAllocString(b);
   b = "geom!" + (_bstr_t) GeomType;
   IntName = SysAllocString(b);
   lpDisp = SIGeometries->Add(&ExternalName, &IntName, &GeomType, &IntName);
   // NewGeom = new _SIGeometry(lpDisp);

   // Get shapefile field defs and add to project table

   IsKey = FALSE;
   hResult = Helper.do_dispparams(L"get_field_defs", &NoArgs, &vResult);
      // assume hresult == S_OK and V_VT(&vResult) == VT_DISPATCH
   V.init(V_DISPATCH(&vResult));

   hResult = V.get(L"size", &vResult);  // returns VT_I4
   size = vResult.lVal;
   for(i = 1; i <= size; i++)
   {

      // Get field def entry i

      vArg.lVal = i;
      vArg.vt = VT_I4;
      hResult = V.do_variant(L"nth", &vArg, &vResult);
         // assume hresult == S_OK and V_VT(&vResult) == VT_DISPATCH
      D.init(V_DISPATCH(&vResult));

      // Get name and type

      vArg.lVal = 1;
      vArg.vt = VT_I4;
      hResult = D.do_variant(L"nth", &vArg, &vResult);
      // returns VT_BSTR
      ExternalName = vResult.bstrVal;
      vArg.lVal = 2;
      hResult = D.do_variant(L"nth", &vArg, &vResult);
      // returns VT_BSTR
      fieldType = vResult.bstrVal;
      IntName = SysAllocString((_bstr_t) _strlwr((char *) ((_bstr_t) ExternalName)));

      // Add field

      lpDisp = SIFields->Add(&fieldType, &IsKey, &IntName, &ExternalName, &IntName);
      delete NewField;
      NewField = new _SIField(lpDisp);
      NewField->SetVisible(TRUE);
      NewField->SetIsGenerated(&IsKey);

   }

   // Add table to project

   lpDisp = SITables->CreateStaticTable(&(dTable->m_lpDispatch));
   pTable = new _SIProjectTable(lpDisp);

   // Set internal table name on Helper

   Success = TRUE;
   cIntName = pTable->GetIntName();
   vArg.SetString(cIntName);
   hResult = Helper.do_variant(L"set_table_name", &vArg, &vResult);
      // returns VT_BOOL
   if (!vResult.boolVal)
   {
      AfxMessageBox(_T("Error: unable to associate project table with helper."));
      Success = FALSE;
   }

   // Clean up

   delete NewField;
   delete SIFields;
   delete SIGeometries;
   delete pTable;
   delete dTable;
   delete SITables;

   return Success;

}

BOOL SiSLDlg::TableExists(_SIProjectTables *SITables)
{

   _variant_t vArg;
   long size;
   LPDISPATCH lpDisp;

   // If SITables is empty, return FALSE

   size = SITables->GetCount();
   if (size == 0)
      return FALSE;

   // Otherwise, see if getting the table leads to an error

   vArg.SetString(m_sTabName);
   try
   {
      lpDisp = SITables->GetItem(&vArg);
   }
   catch(...)
   {
      return FALSE;
   }
   return TRUE;

}

